%% Matching modulus to entropy and features at AE hits
clear all
clc

% Load AE features and modulus data
load('C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A1619212223242526_hitdata_061516.mat');
load('C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\modulus_061516.mat');
load('C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\fittedModulusCurves.mat');

% Already in loaded data
% testsStr = {'5A16','5A19','5A21','5A22','5A23','5A24','5A25','5A26'};
% testNumber = [16,19,21,22,23,24,25,26];
% numOfTests = length(testNumber);
% crackInitTime = [4200 1582 4950 3130 6329 3420 3638 5822]; %s
% crack025mmTime = [4260 1697 5612 3145 7276 3505 3682 6067]; %s
% crack1mmTime = [4410 1757 6343 3231 8099 3701 3939 6222]; %s
% peakTimeMTS = [10.36 10.36 10.44 10.35 10.39 10.35 10.37 10.40];
% peakTimeAE = [10 10.16 10.68 10.36 9.82 10.54 10.56 10.26];

% Preallocate
featureEntropy = cell(numOfTests,1);
updatedEntropy = cell(numOfTests,1);
tempEntropy = cell(numOfTests,1);
countsFromWaveformsA = cell(numOfTests,1);
timeFromWaveforms = cell(numOfTests,1);

% Load entropy data
workspaceNames = {'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A16_entropy_061316.mat';...
    'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A19_entropy_061316.mat';...
    'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A21_entropy_061316.mat';...
    'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A22_entropy_061316.mat';...
    'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A23_entropy_061316.mat';...
    'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A24_entropy_061316.mat';...
    'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A25_entropy_061316.mat';...
    'C:\Users\Lab Admin\Documents\AAAFiles, 040816\00_Thesis\Results\5A26_entropy_061316.mat'};
for I = 1:length(testsStr)
    clearvars countsFromWaveforms entropy1 entropy2 maximum maxLoad time thresholdDB chooseTestInd testStr freq
    load(workspaceNames{I});
    featureEntropy{I,1} = entropy1(:,2);
    updatedEntropy{I,1} = entropy2(:,2);
    tempEntropy{I,1} = entropy3(:,2);
    countsFromWaveformsA{I,1} = countsFromWaveforms(:,2);
    timeFromWaveforms{I,1} = time;
end
% Load fitted model coefficients
coeff = [fittedmodel1.a fittedmodel1.b;...
    fittedmodel2.a fittedmodel2.b;...
    fittedmodel3.a fittedmodel3.b;...
    fittedmodel4.a fittedmodel4.b;...
    fittedmodel5.a fittedmodel5.b;...
    fittedmodel6.a fittedmodel6.b;...
    fittedmodel7.a fittedmodel7.b;...
    fittedmodel8.a fittedmodel8.b];

% Concatenate AE feature data
hitdata = {hitdata_5A16_mat;hitdata_5A19_mat;hitdata_5A21_mat;hitdata_5A22_mat;...
    hitdata_5A23_mat;hitdata_5A24_mat;hitdata_5A25_mat;hitdata_5A26_mat};
labels = {'Time','Load','Exten','Risetime','Counts','Duration','Amplitude',...
    'Abs Energy','Updated Entropy','Feature Entropy','Temporally-Weighted Entropy'};

% Preallocate
time = cell(numOfTests,1);
load = cell(numOfTests,1);
exten = cell(numOfTests,1);
risetime = cell(numOfTests,1);
counts = cell(numOfTests,1);
duration = cell(numOfTests,1);
amp = cell(numOfTests,1);
energy = cell(numOfTests,1);
channel1 = cell(numOfTests,1);
channel2 = cell(numOfTests,1);
cycles = cell(numOfTests,1);
changeInModAtHit = cell(numOfTests,1);
damage = cell(numOfTests,1);
cumuFeat = cell(numOfTests,1);
cumuEnergy = cell(numOfTests,1);
cumuCounts = cell(numOfTests,1);
stopInd1 = zeros(numOfTests,1);
stopInd2 = zeros(numOfTests,1);
stopInd3 = zeros(numOfTests,1);
stopInd4 = zeros(numOfTests,1);

for i = 1:numOfTests
    counter1 = 1;
    counter2 = 1;
    % Divide hit data into channel 1 and channel 2
    for j = 1:length(hitdata{i})
        if hitdata{i}(j,4) == 1
            channel1{i}(counter1,:) = hitdata{i}(j,:);
            counter1 = counter1 + 1;
        else
            channel2{i}(counter2,:) = hitdata{i}(j,:);
            counter2 = counter2 + 1;
        end
    end

    time{i,1} = channel2{i}(:,1)-peakTimeAE(i);
    load{i,1} = channel2{i}(:,2);
    exten{i,1} = channel2{i}(:,3);
    risetime{i,1} = channel2{i}(:,5);
    counts{i,1} = channel2{i}(:,6);
    duration{i,1} = channel2{i}(:,7);
    amp{i,1} = channel2{i}(:,8);
    energy{i,1} = channel2{i}(:,9);
    cycles{i,1} = time{i,1}*5;
    % updatedEntropy{i,1} = already got
    % featureEntropy{i,1} = already got
    stopInd1(i,1) = find(time{i,1}>crackInitTime(i),1);
    stopInd2(i,1) = find(time{i,1}>crack025mmTime(i),1);
    stopInd3(i,1) = find(time{i,1}>crack1mmTime(i),1);
    stopInd4(i,1) = length(time{i,1}); %Fracture
    
    % Find estimated modulus at AE hits
    % Exp model: change in modulus = a*exp(b*Cycles)
    changeInModAtHit{i,1} = coeff(i,1)*exp(coeff(i,2)*cycles{i,1});
    damage{i,1} = -changeInModAtHit{i,1};
    cumuCounts{i,1} = cumsum(counts{i,1});
    cumuEnergy{i,1} = cumsum(energy{i,1});
    cumuFeat{i,1} = cumsum(featureEntropy{i,1});
end